diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
index bba540b80..0686b8a7a 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFlower;
 import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.world.World;
 
@@ -13,10 +12,11 @@ import java.util.Random;
 
 public class WorldFeatureDeadBush extends WorldFeature
 {
-
-    public WorldFeatureDeadBush(int i)
+    private final int blockId;
+    @MethodParametersAnnotation(names = {"blockId"})
+    public WorldFeatureDeadBush(int blockId)
     {
-        field_28058_a = i;
+        this.blockId = blockId;
     }
 
     @Override
@@ -28,14 +28,12 @@ public class WorldFeatureDeadBush extends WorldFeature
             int j1 = (x + random.nextInt(8)) - random.nextInt(8);
             int k1 = (y + random.nextInt(4)) - random.nextInt(4);
             int l1 = (z + random.nextInt(8)) - random.nextInt(8);
-            if(world.isAirBlock(j1, k1, l1) && ((BlockFlower)Block.blocksList[field_28058_a]).canBlockStay(world, j1, k1, l1))
+            if(world.isAirBlock(j1, k1, l1) && Block.blocksList[blockId].canBlockStay(world, j1, k1, l1))
             {
-                world.setBlock(j1, k1, l1, field_28058_a);
+                world.setBlock(j1, k1, l1, blockId);
             }
         }
 
         return true;
     }
-
-    private int field_28058_a;
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
index 8a381d4a5..ce0c56b13 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDungeon.java
@@ -24,6 +24,7 @@ public class WorldFeatureDungeon extends WorldFeature
     public WeightedRandomBag<WeightedRandomLootObject> chestLoot;
     public WeightedRandomBag<String> spawnerMonsters;
 
+    @MethodParametersAnnotation(names = {"blockIdWalls", "blockIdFloor", "mobOverrideDispatcherId"})
     public WorldFeatureDungeon(int blockIdWalls, int blockIdFloor, String mobOverride)
     {
     	this.blockIdWalls = blockIdWalls;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
index af123fc00..98053cc51 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFlower;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -11,10 +10,11 @@ import java.util.Random;
 
 public class WorldFeatureFlowers extends WorldFeature
 {
-
-    public WorldFeatureFlowers(int i)
+    private final int plantBlockId;
+    @MethodParametersAnnotation(names = {"plantBlockId"})
+    public WorldFeatureFlowers(int plantBlockId)
     {
-        plantBlockId = i;
+        this.plantBlockId = plantBlockId;
     }
 
     @Override
@@ -25,7 +25,7 @@ public class WorldFeatureFlowers extends WorldFeature
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
             int j1 = (y + random.nextInt(4)) - random.nextInt(4);
             int k1 = (z + random.nextInt(8)) - random.nextInt(8);
-            if(world.isAirBlock(i1, j1, k1) && ((BlockFlower) Block.blocksList[plantBlockId]).canBlockStay(world, i1, j1, k1))
+            if(world.isAirBlock(i1, j1, k1) && Block.blocksList[plantBlockId].canBlockStay(world, i1, j1, k1))
             {
                 world.setBlock(i1, j1, k1, plantBlockId);
             }
@@ -33,6 +33,4 @@ public class WorldFeatureFlowers extends WorldFeature
 
         return true;
     }
-
-    private int plantBlockId;
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGrassPatch.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGrassPatch.java
index a7dc90944..40d66b808 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGrassPatch.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGrassPatch.java
@@ -11,7 +11,7 @@ import java.util.Random;
 
 public class WorldFeatureGrassPatch extends WorldFeature
 {
-
+    @MethodParametersAnnotation(names = {"size", "blockToPlace"})
     public WorldFeatureGrassPatch(int size, int blockToPlace)
     {
         numberOfBlocks = size;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
index 95909c946..bfed04599 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
@@ -14,7 +14,7 @@ import java.util.Random;
 
 public class WorldFeatureLake extends WorldFeature
 {
-
+    @MethodParametersAnnotation(names = {"liquidId"})
     public WorldFeatureLake(int liquidId)
     {
         this.liquidId = liquidId;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
index 3bea9f268..d82871189 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
@@ -10,10 +10,10 @@ import java.util.Random;
 
 public class WorldFeatureLiquid extends WorldFeature
 {
-
-    public WorldFeatureLiquid(int i)
+    @MethodParametersAnnotation(names = {"liquidId"})
+    public WorldFeatureLiquid(int liquidId)
     {
-        liquidBlockId = i;
+        liquidBlockId = liquidId;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
index 7117c3419..61d5ef9a9 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
@@ -3,14 +3,12 @@ package net.minecraft.core.world.generate.feature;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.world.World;
-import org.lwjgl.Sys;
 
-import java.util.List;
 import java.util.Random;
 
 public class WorldFeatureMeadow extends WorldFeature
 {
-
+    @MethodParametersAnnotation(names = {"blockIds"})
     public WorldFeatureMeadow(int[] blockIds)
     {
         this.blockIds = blockIds;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
index 2cbe9ba53..ca185c8d6 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
@@ -10,10 +10,11 @@ import java.util.Random;
 
 public class WorldFeatureNetherLava extends WorldFeature
 {
-
-    public WorldFeatureNetherLava(int i)
+    private final int blockId;
+    @MethodParametersAnnotation(names = {"blockId"})
+    public WorldFeatureNetherLava(int blockId)
     {
-        field_4158_a = i;
+        this.blockId = blockId;
     }
 
     @Override
@@ -71,13 +72,11 @@ public class WorldFeatureNetherLava extends WorldFeature
         }
         if(l == 4 && i1 == 1)
         {
-            world.setBlockWithNotify(x, y, z, field_4158_a);
+            world.setBlockWithNotify(x, y, z, blockId);
             world.scheduledUpdatesAreImmediate = true;
-            Block.blocksList[field_4158_a].updateTick(world, x, y, z, random);
+            Block.blocksList[blockId].updateTick(world, x, y, z, random);
             world.scheduledUpdatesAreImmediate = false;
         }
         return true;
     }
-
-    private int field_4158_a;
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
index 2e2db1ad1..3326a24fe 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
@@ -11,7 +11,7 @@ import java.util.Random;
 
 public class WorldFeatureOre extends WorldFeature
 {
-
+    @MethodParametersAnnotation(names = {"blockId", "numberOfBlocks", "hasStoneStates"})
     public WorldFeatureOre(int blockId, int numberOfBlocks, boolean hasStoneStates)
     {
         minableBlockId = blockId;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRichScorchedDirt.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRichScorchedDirt.java
index 0dcddb99d..dcf3ff191 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRichScorchedDirt.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRichScorchedDirt.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -11,10 +10,10 @@ import java.util.Random;
 
 public class WorldFeatureRichScorchedDirt extends WorldFeature
 {
-
-    public WorldFeatureRichScorchedDirt(int j)
+    @MethodParametersAnnotation(names = {"numberOfBlocks"})
+    public WorldFeatureRichScorchedDirt(int numberOfBlocks)
     {
-        numberOfBlocks = j;
+        this.numberOfBlocks = numberOfBlocks;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
index 865e4b71f..ec473a14a 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
@@ -12,16 +12,20 @@ import java.util.Random;
 
 public class WorldFeatureTallGrass extends WorldFeature
 {
-
-    public WorldFeatureTallGrass(int i)
+    private final int blockId;
+    @MethodParametersAnnotation(names = {"blockId"})
+    public WorldFeatureTallGrass(int blockId)
     {
-        blockId = i;
+        this.blockId = blockId;
     }
 
     @Override
 	public boolean generate(World world, Random random, int x, int y, int z)
     {
-        for(int l = 0; ((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
+        int l;
+        while (((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BlockLeavesBase) && y > 0) {
+            y--;
+        }
         for(int i1 = 0; i1 < 128; i1++)
         {
             int j1 = (x + random.nextInt(8)) - random.nextInt(8);
@@ -38,6 +42,4 @@ public class WorldFeatureTallGrass extends WorldFeature
 
         return true;
     }
-
-    private int blockId;
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
index c4cc702be..5836b8c06 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
@@ -1,18 +1,20 @@
 package net.minecraft.core.world.generate.feature.tree;
 
-import java.util.Random;
-
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
+import java.util.Random;
+
 public class WorldFeatureTree extends WorldFeature
 {
 	protected int leavesID;
 	protected int logID;
 	protected int heightMod;
-	
+
+    @MethodParametersAnnotation(names = {"leavesID", "logID", "heightMod"})
     public WorldFeatureTree(int leavesID, int logID, int heightMod)
     {
     	this.leavesID = leavesID;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
index 5f990d1b3..29388dc5e 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCaatinga.java
@@ -1,19 +1,21 @@
 package net.minecraft.core.world.generate.feature.tree;
 
-import java.util.Random;
-
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
+import java.util.Random;
+
 public class WorldFeatureTreeCaatinga extends WorldFeature
 {
     protected int leavesID;
     protected int logID;
     protected int heightMod = 3;
 
+    @MethodParametersAnnotation(names = {"leavesID", "logID"})
     public WorldFeatureTreeCaatinga(int leavesID, int logID)
     {
         this.leavesID = leavesID;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
index 9338759c5..ec9563044 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
@@ -1,13 +1,15 @@
 package net.minecraft.core.world.generate.feature.tree;
 
-import java.util.Random;
-
 import net.minecraft.core.block.Block;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.season.Seasons;
 
+import java.util.Random;
+
 public class WorldFeatureTreeCherry extends WorldFeatureTree {
 
+	@MethodParametersAnnotation(names = {"leavesID", "logID", "heightMod"})
 	public WorldFeatureTreeCherry(int leavesID, int logID, int heightMod) {
 		super(leavesID, logID, heightMod);
 	}
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java
index 61025a4fa..8e3ed9176 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeEucalyptus.java
@@ -4,6 +4,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
@@ -12,14 +13,14 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
 {
     protected int leavesID;
     protected int logID;
-
+    @MethodParametersAnnotation(names = {"leavesID", "logID"})
     public WorldFeatureTreeEucalyptus(int leavesID, int logID)
     {
         field_881_b = new Random();
         field_878_e = 0;
-        field_876_g = 0.38100000000000001D;
+        field_876_g = 0.381D;
         field_875_h = 1.0D;
-        field_874_i = 0.38100000000000001D;
+        field_874_i = 0.381D;
         field_873_j = 1.0D;
         field_872_k = 1.0D;
         field_871_l = 1;
@@ -36,7 +37,7 @@ public class WorldFeatureTreeEucalyptus extends WorldFeature
         {
             height = field_878_e - 1;
         }
-        int i = (int)(1.38100000000000001D + java.lang.Math.pow((field_872_k * (double)field_878_e) / 7D, 2D));
+        int i = (int)(1.381D + java.lang.Math.pow((field_872_k * (double)field_878_e) / 7D, 2D));
         if(i < 1)
         {
             i = 1;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java
index 509a2e260..fa853cf7c 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancy.java
@@ -4,6 +4,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
@@ -34,12 +35,14 @@ public class WorldFeatureTreeFancy extends WorldFeature
     int leavesHeight;
     int[][] foliageCoords;
     int heightMod;
-	
+
+    @MethodParametersAnnotation(names = {"leavesID", "logID"})
     public WorldFeatureTreeFancy(int leavesID, int logID)
     {
         this(leavesID, logID, 0);
     }
 
+    @MethodParametersAnnotation(names = {"leavesID", "logID", "heightMod"})
     public WorldFeatureTreeFancy(int leavesID, int logID, int heightMod)
     {
         treeRand = new Random();
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java
index 373f1ce31..3456bdc86 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java
@@ -4,6 +4,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
@@ -15,7 +16,7 @@ public class WorldFeatureTreeFancyRainforest extends WorldFeature
 {
 	protected int leavesID;
 	protected int logID;
-	
+    @MethodParametersAnnotation(names = {"leavesID", "logID"})
     public WorldFeatureTreeFancyRainforest(int leavesID, int logID)
     {
         treeRand = new Random();
@@ -32,7 +33,7 @@ public class WorldFeatureTreeFancyRainforest extends WorldFeature
         this.logID = logID;
         this.heightMod = 0;
     }
-
+    @MethodParametersAnnotation(names = {"leavesID", "logID", "heightMod"})
     public WorldFeatureTreeFancyRainforest(int leavesID, int logID, int heightMod)
     {
         treeRand = new Random();
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
index 76e0e2904..70641d5bc 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
@@ -1,11 +1,5 @@
 package net.minecraft.core.world.generate.feature.tree;
 
-import java.util.ArrayList;
-import java.util.HashSet;
-import java.util.List;
-import java.util.Random;
-import java.util.Set;
-
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockFlower;
 import net.minecraft.core.block.BlockLeavesBase;
@@ -15,8 +9,15 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.ChunkPosition;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Random;
+import java.util.Set;
+
 public class WorldFeatureTreePalm extends WorldFeature {
 	
 	protected World world;
@@ -51,7 +52,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 	
 	protected Set<Integer> intSet = new HashSet<>();
 	protected List<Integer> intList = new ArrayList<>();
-	
+	@MethodParametersAnnotation(names = {"log", "leaves", "big", "update"})
 	public WorldFeatureTreePalm(Block log, Block leaves, boolean big, boolean update) {
 		this.log = log;
 		this.leaves = leaves;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java
index 0390a43fb..f8993efec 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.generate.feature.tree;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.WorldFeatureAlgae;
 
@@ -18,7 +19,7 @@ public class WorldFeatureTreeShapeSwamp extends WorldFeature
     protected int logID;
     protected int heightMod;
     protected Random treeRand = new Random();
-
+    @MethodParametersAnnotation(names = {"leavesID", "logID", "heightMod"})
     public WorldFeatureTreeShapeSwamp(int leavesID, int logID, int heightMod)
     {
         this.leavesID = leavesID;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java
index f9b2b35bb..0f212cbba 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.generate.feature.tree;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
 
@@ -18,6 +19,7 @@ public class WorldFeatureTreeShrub extends WorldFeature
     protected int leavesID;
     protected int logID;
 
+    @MethodParametersAnnotation(names = {"leavesID", "logID"})
     public WorldFeatureTreeShrub(int leavesID, int logID)
     {
         this.leavesID = leavesID;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java
index f1d744d34..70bea77a4 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.generate.feature.tree;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
@@ -15,7 +16,8 @@ public class WorldFeatureTreeTaigaBushy extends WorldFeature
 {
 	protected int leavesID;
 	protected int logID;
-	
+
+    @MethodParametersAnnotation(names = {"leavesID", "logID"})
     public WorldFeatureTreeTaigaBushy(int leavesID, int logID)
     {
     	this.leavesID = leavesID;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java
index df0ed9589..9e6dfc7bf 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.generate.feature.tree;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
@@ -15,7 +16,7 @@ public class WorldFeatureTreeTaigaTall extends WorldFeature
 {
 	protected int leavesID;
 	protected int logID;
-	
+    @MethodParametersAnnotation(names = {"leavesID", "logID"})
     public WorldFeatureTreeTaigaTall(int leavesID, int logID)
     {
     	this.leavesID = leavesID;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java
index fb9faad2d..ffcec1a3b 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.generate.feature.tree;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
@@ -16,6 +17,7 @@ public class WorldFeatureTreeTall extends WorldFeature
     protected int leavesID;
     protected int logID;
 
+    @MethodParametersAnnotation(names = {"leavesID", "logID"})
     public WorldFeatureTreeTall(int leavesID, int logID)
     {
         this.leavesID = leavesID;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeThorn.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeThorn.java
index 56b639727..99907a0a3 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeThorn.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeThorn.java
@@ -1,12 +1,14 @@
 package net.minecraft.core.world.generate.feature.tree;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.tree.spooner.WorldFeatureSpoonerTreeProcedural;
 
 import java.util.ArrayList;
 import java.util.List;
 
 public class WorldFeatureTreeThorn extends WorldFeatureSpoonerTreeProcedural {
+    @MethodParametersAnnotation(names = {"height", "trunkId", "trunkData", "leavesId", "leavesData"})
     public WorldFeatureTreeThorn(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
         super(height, trunkId, trunkData, leavesId, leavesData);
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
index 88819efd1..9e14f2184 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.generate.feature.tree.spooner;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.List;
@@ -61,6 +62,7 @@ public abstract class WorldFeatureSpoonerTree
 
     protected Random random = null;
 
+    @MethodParametersAnnotation(names = {"height", "trunkId", "trunkData", "leavesId", "leavesData"})
     public WorldFeatureSpoonerTree(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
         this.height = height;
         this.trunkId = trunkId;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeBamboo.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeBamboo.java
index 2a5eaead6..2f51735d1 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeBamboo.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeBamboo.java
@@ -1,9 +1,11 @@
 package net.minecraft.core.world.generate.feature.tree.spooner;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 
 public class WorldFeatureSpoonerTreeBamboo
     extends WorldFeatureSpoonerTreeStick {
+    @MethodParametersAnnotation(names = {"height", "trunkId", "trunkData", "leavesId", "leavesData"})
     public WorldFeatureSpoonerTreeBamboo(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
         super(height, trunkId, trunkData, leavesId, leavesData);
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeCone.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeCone.java
index a58b13990..404446df8 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeCone.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeCone.java
@@ -1,9 +1,11 @@
 package net.minecraft.core.world.generate.feature.tree.spooner;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 
 public class WorldFeatureSpoonerTreeCone
     extends WorldFeatureSpoonerTreeProcedural {
+    @MethodParametersAnnotation(names = {"height", "trunkId", "trunkData", "leavesId", "leavesData"})
     public WorldFeatureSpoonerTreeCone(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
         super(height, trunkId, trunkData, leavesId, leavesData);
     }
